﻿using System;

using SI_Class;

/// <summary> Develop, Test, and Validate SI_Class
/// </summary>
public class SI_Validate
{
	public static void Main (string[] args)
	{
		Console.Title = "SI_Validate";
		Validate ();
		Console.WriteLine ();
		Console.Write ("Type the ENTER key when ready...");
		Console.ReadLine ();
	}
	/// <summary> Demonstrate and validate (by visual observation) some test numbers
	/// </summary>
	static void Validate ()
	{
		Validate (0);
		Validate20 (1000);
		Validate20 (1490);
		Validate20 (1499);
		Validate20 (1500);
		Validate20 (1550);
		Console.WriteLine ("\tInt64.MaxValue");
		Validate (Int64.MaxValue);
		Console.WriteLine ("\tUInt64.MaxValue");
		Validate (UInt64.MaxValue);
	}
	/// <summary> Demonstrate and validate (by visual observation) a 20 magnitude range of a number
	/// </summary>
	static void Validate20 (UInt64 number)
	{
		for (int i = -3; i < 17; ++i)
			Validate ((UInt64) (number * Math.Pow (10, i)));
	}
	/// <summary> Demonstrate and validate (by visual observation) a numeric value
	/// </summary>
	/// <param name="str">The string value to convert to numeric</param> 
	static void Validate (UInt64 number)
	{
		string str = SI.ToString (number);
		Console.WriteLine (number.ToString ().PadLeft (20)
			+ " = " + str.PadLeft (4)
			+ " = " + SI.ParseU64 (str).ToString ().PadLeft (20));
	}

}
